#include <iostream>
#include <math.h>
#include "TChain.h"
#include "TCanvas.h"
#include "TString.h"
#include "TFile.h"
#include "TTree.h"
#include "TH1.h"
#include "TH2.h"
#include "string.h"
#include "stdlib.h"
#include "Ppac_prm.h"
using namespace std;
int main(){

 int runmin,runmax;
 printf("Give the run min. and max. : ");
 scanf("%d%d",&runmin,&runmax);
 for(int runnum=runmin;runnum<=runmax;runnum++){
   char filename[200];
   char fileout[250];
   char h_name[150];
   sprintf(filename,"../rootfile/%04d.root",runnum);
   sprintf(fileout,"../cali_rootfile/calied%04d.root",runnum);
   printf("Now process file %s\n ",filename);
   printf("the outputfile file %s\n ",fileout);

   TFile *fin = new TFile(filename);
    if(fin->IsZombie()){
      printf("Open file %s error... \n",filename);
      continue;
    }
    
    TTree *tree = (TTree*)fin->Get("tree");
    unsigned int nentries = tree->GetEntries();
    printf(" Entries: %d\n",nentries);

    TFile *fout = new TFile(fileout,"RECREATE"); 
    TTree *crib = new TTree("crib","crib");    
    double percent = 0;
//======================================================
//orignial branches, modify them according to your recipe    
//======================================================
    short  fRf[96];
    short  fF1ppac[96];
    short  fPpac[9][96]; //the order is F3PPACa, F3PPACb, F2PPAC
    short  fCr[96];
    short  fPsdE[9][96];
    short  fF2SsdE[96];
    short  fSsdE[96];
    short  fHpsdE[9][96];
    short  fPsdT[9][96];
    short  fSsdT[96];
    short  fHpsdT1[96];
    short  fHpsdT2[96];
    short  fHpsdT3[96];
    short  fHpsdT4[96];
    short  fHpsdT5[96];
    short  fHpsdT6[96];

    tree->SetBranchAddress("fRf",fRf);
    tree->SetBranchAddress("fF1ppac",fF1ppac);
    tree->SetBranchAddress("fPpac",fPpac);
    tree->SetBranchAddress("fCr",fCr);
    tree->SetBranchAddress("fPsdE",fPsdE);
    tree->SetBranchAddress("fF2SsdE",fF2SsdE);
    tree->SetBranchAddress("fSsdE",fSsdE);
    tree->SetBranchAddress("fHpsdE",fHpsdE);
    tree->SetBranchAddress("fPsdT",fPsdT);
    tree->SetBranchAddress("fSsdT",fSsdT);
    tree->SetBranchAddress("fHpsdT1",fHpsdT1);
    tree->SetBranchAddress("fHpsdT2",fHpsdT2);
    tree->SetBranchAddress("fHpsdT3",fHpsdT3);
    tree->SetBranchAddress("fHpsdT4",fHpsdT4);
    tree->SetBranchAddress("fHpsdT5",fHpsdT5);
    tree->SetBranchAddress("fHpsdT6",fHpsdT6);
//======================================================
//the calibrated branches 
//======================================================
    float Rf[2];
    float F1ppac[5];
    float Ppac[3][5]; 
    float Cr[3];
    float PsdE[2][16];
    float F2SsdE;
    float SsdE[6];
    float HpsdE[6];
    float PsdT[2][16];
    float SsdT[6];
    float HpsdT[6];
    float F3Ppaca_x, F3Ppaca_y, F3Ppacb_x, F3Ppacb_y, F2Ppac_x, F2Ppac_y;
    float F3Ppaca_time, F3Ppacb_time, F1Ppac_time, F2Ppac_time;
    float F1ppac_x, F1ppac_y, F1ppac_x_beam, F1ppac_y_beam;
    crib->Branch("Rf",Rf,"Rf[2]/F");
    crib->Branch("F1ppac",F1ppac,"F1ppac[5]/F");
    crib->Branch("Ppac",Ppac,"ppac[3][5]/F");
    crib->Branch("Cr",Cr,"Cr[3]/F");
    crib->Branch("PsdE",PsdE,"PsdE[2][16]/F");
    crib->Branch("F2SsdE",&F2SsdE,"F2SsdE/F");
    crib->Branch("SsdE",SsdE,"SsdE[6]/F");
    crib->Branch("HpsdE",HpsdE,"HpsdE[6]/F");
    crib->Branch("PsdT",PsdT,"PsdT[2][16]/F");
    crib->Branch("SsdT",SsdT,"SsdT[6]/F");
    crib->Branch("HpsdT",HpsdT,"HpsdT[6]/F");
    crib->Branch("F1ppac_x",&F1ppac_x,"F1ppac_x/F");
    crib->Branch("F1ppac_y",&F1ppac_y,"F1ppac_y/F");
    crib->Branch("F1ppac_x_beam",&F1ppac_x_beam,"F1ppac_x_beam/F");
    crib->Branch("F1ppac_y_beam",&F1ppac_y_beam,"F1ppac_y_beam/F");
    crib->Branch("F3Ppaca_x",&F3Ppaca_x,"F3Ppaca_x/F");
    crib->Branch("F3Ppaca_y",&F3Ppaca_y,"F3Ppaca_y/F");
    crib->Branch("F3Ppacb_x",&F3Ppacb_x,"F3Ppacb_x/F");
    crib->Branch("F3Ppacb_y",&F3Ppacb_y,"F3Ppacb_y/F");
    crib->Branch("F2Ppac_x",&F2Ppac_x,"F2Ppac_x/F");
    crib->Branch("F2Ppac_y",&F2Ppac_y,"F2Ppac_y/F");
    crib->Branch("F3Ppaca_time",&F3Ppaca_time,"F3Ppaca_time/F");
    crib->Branch("F3Ppacb_time",&F3Ppacb_time,"F3Ppacb_time/F");
    crib->Branch("F1Ppac_time",&F1Ppac_time,"F1Ppac_time/F");
    crib->Branch("F2Ppac_time",&F2Ppac_time,"F2Ppac_time/F");
    
   for(int i=0;i<nentries;++i){ //fill branches
   
       tree->GetEntry(i);

//========== initialization ======================  
        for(int ii=0;ii<2;ii++){       
            Rf[ii] = -100;
         }
        for(int ii=0;ii<5;ii++){
            F1ppac[ii] = -10;
        }
        for(int ii=0;ii<3;ii++){
           for(int jj=0;jj<5;jj++){
            Ppac[ii][jj] = -10;
           }
        }
        for(int ii=0;ii<3;ii++){
            Cr[ii] = -10;
        }
        for(int ii=0;ii<2;ii++){
          for(int jj=0;jj<16;jj++){
            PsdE[ii][jj] = -10;
           }
        }
        F2SsdE = -10;
          for(int jj=0;jj<6;jj++){
            SsdE[jj] = -10;
           }
        for(int ii=0;ii<2;ii++){
          for(int jj=0;jj<16;jj++){
            PsdT[ii][jj] = -10;
           }
        }
          for(int jj=0;jj<6;jj++){
            SsdT[jj] = -10;
           }
        for(int ii=0;ii<6;ii++){
            HpsdE[ii] = -10;
           }
        for(int ii=0;ii<6;ii++){
            HpsdT[ii] = -10;
        }
        
        F1ppac_x = -10;
        F1ppac_y = -10;
        F1ppac_x_beam = -10;
        F1ppac_y_beam = -10;
        F3Ppaca_x = -10; 
        F3Ppaca_y = -10; 
        F3Ppacb_x = -10;
        F3Ppacb_y = -10;
        F1Ppac_time = -10;
        F2Ppac_time = -10;
        F3Ppaca_time = -10;
        F3Ppacb_time = -10;
        F2Ppac_x = -10;
        F2Ppac_y = -10;

//========== end of initialization ======================  

//========== PPAC position calibration (F3PPACa  F3PPACb F2PPAC) ==========================
    Ppac_prm *ppacprm = new Ppac_prm();
    ppacprm->ReadPpacPara();
    for(int ii=0;ii<3;ii++){
      for(int jj=0;jj<4;jj++){//for x1 x2 y1 y2:
          if(fPpac[ii][jj]>0.&&fPpac[ii][jj]<4090.){
              Ppac[ii][jj] = fPpac[ii][jj]*ppacprm->Gain_PPAC[ii][jj]+ppacprm->Off_PPAC[ii][jj];
          }
       Ppac[ii][4] = fPpac[ii][4];//anode
      }
      float TXsum[3], dTX[3];
      float TYsum[3], dTY[3];
      float Xcal[3], Ycal[3];
      float ppac_x[3], ppac_y[3];

      for(int ii=0;ii<3;ii++){
          if(Ppac[ii][0]>0.&&Ppac[ii][1]>0.){
            TXsum[ii] = Ppac[ii][0] + Ppac[ii][1];
            dTX[ii] = Ppac[ii][0] - Ppac[ii][1];
            if(ppacprm->iflag_position_offset == 1){
            dTX[ii] -= ppacprm->offset_x[ii];
            }
            else if(ppacprm->iflag_position_offset_line == 1){
            dTX[ii] -= ppacprm->offset_line_x[ii];
            }
            Xcal[ii] = dTX[ii];
          }
          if(Ppac[ii][2]>0.&&Ppac[ii][3]>0.){
            TYsum[ii] = Ppac[ii][2] + Ppac[ii][3];
            dTY[ii] = Ppac[ii][2] - Ppac[ii][3];
            if(ppacprm->iflag_position_offset == 1){
            dTY[ii] -= ppacprm->offset_y[ii];
            }
            else if(ppacprm->iflag_position_offset_line == 1){
            dTY[ii] -= ppacprm->offset_line_y[ii];
            }
            Ycal[ii] = dTY[ii];
          }
          if(fPpac[ii][0]>0&&fPpac[ii][1]>0&&fPpac[ii][0]<4000&&fPpac[ii][1]<4000){
              ppac_x[ii] = ppacprm->PosGain[ii][0] * Xcal[ii];
              if(ppacprm->iflag_geom_position_offset ==1){
                  ppac_x[ii] -= ppacprm->offset_geom[ii][0];
              }
              else if(ppacprm->iflag_cath_position_offset ==1){
                  ppac_x[ii] -= ppacprm->offset_cath[ii][0];
              }
              else if(ppacprm->iflag_reverse_axis ==1){
                  ppac_x[ii] *= ppacprm->reverse_axis[ii][0];
              }
          }
           if(fPpac[ii][2]>0&&fPpac[ii][3]>0&&fPpac[ii][2]<4000&&fPpac[ii][3]<4000){
              ppac_y[ii] = ppacprm->PosGain[ii][1] * Ycal[ii];
              if(ppacprm->iflag_geom_position_offset ==1){
                  ppac_y[ii] -= ppacprm->offset_geom[ii][1];
              }
              else if(ppacprm->iflag_cath_position_offset ==1){
                  ppac_y[ii] -= ppacprm->offset_cath[ii][1];
              }
              else if(ppacprm->iflag_reverse_axis ==1){
                  ppac_y[ii] *= ppacprm->reverse_axis[ii][1];
              }
           }
      } // end of loop of ii

        F3Ppaca_x = ppac_x[0]; 
        F3Ppaca_y = ppac_y[0]; 
        F3Ppacb_x = ppac_x[1];
        F3Ppacb_y = ppac_y[1];
        F2Ppac_x = ppac_x[2];
        F2Ppac_y = ppac_y[2];
    }
//========== end of PPAC calibration ==============================================

//========== F1PPAC calibration ===================================================
          // the parameters are taken from enc_beam.f         
          F1ppac[0] = (fF1ppac[0] - 34.37) * 1.0;  //x1
          F1ppac[1] = (fF1ppac[1] - 40.08) * 1.0;  //x2
          F1ppac[2] = (fF1ppac[2] - 41.51) * 1.0;  //y1
          F1ppac[3] = (fF1ppac[3] - 36.39) * 1.0;  //y2
          F1ppac[4] = fF1ppac[4]; //anode

          if(fF1ppac[0]>0.&&fF1ppac[1]>0.&&fF1ppac[0]<4000.&&fF1ppac[1]<4000.){
              F1ppac_x = 150.2 * (F1ppac[1]/(F1ppac[1]+F1ppac[0])-0.5)-0.0199;
              F1ppac_x_beam = -F1ppac_x + 3.21;
          }
           if(fF1ppac[2]>0.&&fF1ppac[3]>0.&&fF1ppac[2]<4000.&&fF1ppac[3]<4000.){
              F1ppac_y = 100.92 * (F1ppac[3]/(F1ppac[3]+F1ppac[2])-0.5)-0.0076;
              F1ppac_y_beam = F1ppac_y - 20.7399;
          }
//========== end of F1PPAC calibration ============================================
//
//========== PPAC time calibration (F1 F3 ppac) ============================================

         F1Ppac_time = fF1ppac[4] * 0.12125;

             if(fPpac[0][4]>0&&fPpac[0][4]<4096){
                 F3Ppaca_time = fPpac[0][4] * ppacprm->TGain_PPAC[0] + ppacprm->TOff_PPAC[0];
             }
             if(fPpac[1][4]>0&&fPpac[1][4]<4096){
                 F3Ppacb_time = fPpac[1][4] * ppacprm->TGain_PPAC[1] + ppacprm->TOff_PPAC[1];
             }

             //========== end of PPAC time calibration (F1 F3 ppac) ============================================

//========== RF calibration =======================================================
         //the parameters are taken from beam.prm
          Rf[0] = fRf[0] * 0.12225;
          Rf[1] = fRf[1] * 0.12239;
//========== end of RF calibration ================================================

   for(int ii=0;ii<3;ii++){
        Cr[ii] = fCr[ii];
   }

   F2SsdE = fF2SsdE[0];
//input your own calibraiton parameters for below branches:   
   for(int ii=0;ii<2;ii++){
     for(int jj=0;jj<16;jj++){
       PsdE[ii][jj] = fPsdE[ii][jj];
      }
   }
   for(int jj=0;jj<6;jj++){
       SsdE[jj] = fSsdE[jj];
       HpsdE[jj] = fHpsdE[jj][4];
      }
   for(int ii=0;ii<2;ii++){
     for(int jj=0;jj<16;jj++){
       PsdT[ii][jj] = fPsdT[ii][jj];
      }
   }
     for(int jj=0;jj<6;jj++){
       SsdT[jj] = fSsdT[jj];
      }
     HpsdT[0] = fHpsdT1[0];
     HpsdT[1] = fHpsdT2[0];
     HpsdT[2] = fHpsdT3[0];
     HpsdT[3] = fHpsdT4[0];
     HpsdT[4] = fHpsdT5[0];
     HpsdT[5] = fHpsdT6[0];

  crib->Fill();
       if(i%10000==0)
       cout<<"complete"<<"\t"<<i<<"\t"<<(float)i/nentries*100<<"%"<<endl;
    }// end of loop of envent
        fout->Write();
        fout->Close();
        fin->Close();

 }//end of loop of runnumber
 return 0;
}//end of main()
