#ifndef PPAC_PRM_H
#define PPAC_PRM_H

 #include <iostream>
 #include <fstream>
 #include <string>
 #include <stdio.h>

 using namespace std;

 #define n_ppac 5
 #define n_layer 6

 class Ppac_prm{
 public:
  int IFlag_PPAC;
  int IFlag_Tcalib;
  float TOff_PPAC[n_ppac];
  float TGain_PPAC[n_ppac];
  float Off_PPAC[n_ppac][4];
  float Gain_PPAC[n_ppac][4];
  float PosGain[n_ppac][2];
  float ZPOS[n_layer];
  int iflag_position_offset;
  int iflag_position_offset_line;
  float offset_x[n_ppac];
  float offset_y[n_ppac];
  float offset_line_x[n_ppac];
  float offset_line_y[n_ppac];

  int iflag_geom_position_offset;
  int iflag_cath_position_offset;
  float offset_geom[n_ppac][2];
  float offset_cath[n_ppac][2];
  int iflag_reverse_axis;
  float reverse_axis[n_ppac][2];
  int iflag_Pileup_T0_PPAC;
  float Pileup_T0_PPAC[n_ppac][2];

  float pcubx[10];
  float pcuby[10];
   
  void ReadPpacPara();
 };

void Ppac_prm::ReadPpacPara(){
  char fname[32] = "./ppac.prm";  
  ifstream fprm(fname);
  //Char_t str1l[256] = {'\0'};
  string str1l;

  int l=0;
  while(fprm.good()){
    //while(fgets(str1l, 256, fprm) != NULL){
    getline(fprm, str1l);
    //fprm >> str1l;
    if(str1l[0] != 'c'){
      //cout << str1l << endl;
      l++;
      //fprm.read((char *) &str_prm, sizeof())
      if(l==1){
	sscanf(str1l.c_str(),"%d",&IFlag_PPAC);
	cout << l << " " << IFlag_PPAC << endl;
      }else if(l>=2 && l<2+n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f",
	       &Off_PPAC[l-2][0],&Off_PPAC[l-2][1],
	       &Off_PPAC[l-2][2],&Off_PPAC[l-2][3]);
	cout << l << " " << Off_PPAC[l-2][0] <<","<<Off_PPAC[l-1][1]<<","
	     << Off_PPAC[l-2][2] <<","<<Off_PPAC[l-1][3]<< endl;
      }else if(l>=2+n_ppac && l<2+2*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f",
	       &Gain_PPAC[l-(2+n_ppac)][0],&Gain_PPAC[l-(2+n_ppac)][1],
	       &Gain_PPAC[l-(2+n_ppac)][2],&Gain_PPAC[l-(2+n_ppac)][3]);
	cout << l << " "
	     << Gain_PPAC[l-(2+n_ppac)][0] <<","
	     << Gain_PPAC[l-(2+n_ppac)][1] <<","
	     << Gain_PPAC[l-(2+n_ppac)][2] <<","
	     << Gain_PPAC[l-(2+n_ppac)][3] << endl;
      }else if(l==2+2*n_ppac){
	sscanf(str1l.c_str(),"%d",&IFlag_Tcalib);
	cout << l << " " << IFlag_Tcalib << endl;
      }else if(l==3+2*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &TGain_PPAC[0],&TGain_PPAC[1],&TGain_PPAC[2],
	       &TGain_PPAC[3],&TGain_PPAC[4]);
	cout << l << " "
	     << TGain_PPAC[0] << ","
	     << TGain_PPAC[1] << ","
	     << TGain_PPAC[2] << ","
	     << TGain_PPAC[3] << ","
	     << TGain_PPAC[4] << endl;	
      }else if(l==4+2*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &TOff_PPAC[0],&TOff_PPAC[1],&TOff_PPAC[2],
	       &TOff_PPAC[3],&TOff_PPAC[4]);
	cout << l << " "
	     << TOff_PPAC[0] << ","
	     << TOff_PPAC[1] << ","
	     << TOff_PPAC[2] << ","
	     << TOff_PPAC[3] << ","
	     << TOff_PPAC[4] << endl;	
      }else if(l>=5+2*n_ppac && l<5+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f",
	       &PosGain[l-(5+2*n_ppac)][0],&PosGain[l-(5+2*n_ppac)][1]);
	cout << l << " "
	     << PosGain[l-(5+2*n_ppac)][0] <<","
	     << PosGain[l-(5+2*n_ppac)][1] << endl;
      }else if(l==5+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &ZPOS[0],&ZPOS[1],&ZPOS[2],
	       &ZPOS[3],&ZPOS[4]);
	     //  &ZPOS[3],&ZPOS[4],&ZPOS[5]);
	cout << l << " "
	     << ZPOS[0] << ","
	     << ZPOS[1] << ","
	     << ZPOS[2] << ","
	     << ZPOS[3] << ","
	     << ZPOS[4] << ","
	     << ZPOS[5] << endl;		
      }else if(l==6+3*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_position_offset);
	cout << l << " " << iflag_position_offset << endl;
      }else if(l==7+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &offset_x[0],&offset_x[1],&offset_x[2],
	       &offset_x[3],&offset_x[4]);
	cout << l << " "
	     << offset_x[0] << ","
	     << offset_x[1] << ","
	     << offset_x[2] << ","
	     << offset_x[3] << ","
	     << offset_x[4] << endl;	
      }else if(l==8+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &offset_y[0],&offset_y[1],&offset_y[2],
	       &offset_y[3],&offset_y[4]);
	cout << l << " "
	     << offset_y[0] << ","
	     << offset_y[1] << ","
	     << offset_y[2] << ","
	     << offset_y[3] << ","
	     << offset_y[4] << endl;	
      }else if(l==9+3*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_position_offset_line);
	cout << l << " " << iflag_position_offset_line << endl;
      }else if(l==10+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &offset_line_x[0],&offset_line_x[1],&offset_line_x[2],
	       &offset_line_x[3],&offset_line_x[4]);
	cout << l << " "
	     << offset_line_x[0] << ","
	     << offset_line_x[1] << ","
	     << offset_line_x[2] << ","
	     << offset_line_x[3] << ","
	     << offset_line_x[4] << endl;	
      }else if(l==11+3*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f",
	       &offset_line_y[0],&offset_line_y[1],&offset_line_y[2],
	       &offset_line_y[3],&offset_line_y[4]);
	cout << l << " "
	     << offset_line_y[0] << ","
	     << offset_line_y[1] << ","
	     << offset_line_y[2] << ","
	     << offset_line_y[3] << ","
	     << offset_line_y[4] << endl;	
      }else if(l==12+3*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_geom_position_offset);
	cout << l << " " << iflag_geom_position_offset << endl;
      }else if(l>=13+3*n_ppac && l<13+4*n_ppac){
	sscanf(str1l.c_str(),"%f,%f",
	       &offset_geom[l-(13+3*n_ppac)][0],
	       &offset_geom[l-(13+3*n_ppac)][1]);
	cout << l << " "
	     << offset_geom[l-(13+3*n_ppac)][0] << ","
	     << offset_geom[l-(13+3*n_ppac)][1] << endl;
      }else if(l==13+4*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_cath_position_offset);
	cout << l << " " << iflag_cath_position_offset << endl;
      }else if(l>=14+4*n_ppac && l<14+5*n_ppac){
	sscanf(str1l.c_str(),"%f,%f",
	       &offset_cath[l-(14+4*n_ppac)][0],
	       &offset_cath[l-(14+4*n_ppac)][1]);
	cout << l << " "
	     << offset_cath[l-(14+4*n_ppac)][0] << ","
	     << offset_cath[l-(14+4*n_ppac)][1] << endl;
      }else if(l==14+5*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_reverse_axis);
	cout << l << " " << iflag_reverse_axis << endl;
      }else if(l>=15+5*n_ppac && l<15+6*n_ppac){
	sscanf(str1l.c_str(),"%f,%f",
	       &reverse_axis[l-(15+5*n_ppac)][0],
	       &reverse_axis[l-(15+5*n_ppac)][1]);
	cout << l << " "
	     << reverse_axis[l-(15+5*n_ppac)][0] << ","
	     << reverse_axis[l-(15+5*n_ppac)][1] << endl;
      }else if(l==15+6*n_ppac){
	sscanf(str1l.c_str(),"%d",&iflag_Pileup_T0_PPAC);
	cout << l << " " << iflag_Pileup_T0_PPAC << endl;
      }else if(l>=16+6*n_ppac && l<16+7*n_ppac){
	sscanf(str1l.c_str(),"%f,%f",
	       &Pileup_T0_PPAC[l-(16+6*n_ppac)][0],
	       &Pileup_T0_PPAC[l-(16+6*n_ppac)][1]);
	cout << l << " "
	     << Pileup_T0_PPAC[l-(16+6*n_ppac)][0] << ","
	     << Pileup_T0_PPAC[l-(16+6*n_ppac)][1] << endl;
      }else if(l==16+7*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f,%f,%f,%f,%f,%f",
	       &pcubx[0],&pcubx[1],&pcubx[2],&pcubx[3],&pcubx[4],
	       &pcubx[5],&pcubx[6],&pcubx[7],&pcubx[8],&pcubx[9]);
	cout << l << " "
	     << pcubx[0] << "," << pcubx[1] << ","
	     << pcubx[2] << "," << pcubx[3] << ","
	     << pcubx[4] << "," << pcubx[5] << ","
	     << pcubx[6] << "," << pcubx[7] << ","
	     << pcubx[8] << "," << pcubx[9] << endl;	
      }else if(l==17+7*n_ppac){
	sscanf(str1l.c_str(),"%f,%f,%f,%f,%f,%f,%f,%f,%f,%f",
	       &pcuby[0],&pcuby[1],&pcuby[2],&pcuby[3],&pcuby[4],
	       &pcuby[5],&pcuby[6],&pcuby[7],&pcuby[8],&pcuby[9]);
	cout << l << " "
	     << pcuby[0] << "," << pcuby[1] << ","
	     << pcuby[2] << "," << pcuby[3] << ","
	     << pcuby[4] << "," << pcuby[5] << ","
	     << pcuby[6] << "," << pcuby[7] << ","
	     << pcuby[8] << "," << pcuby[9] << endl;	
      }
    }
  }
  fprm.close();




}







#endif //PPAC_RPM_H
