#ifndef READSEGMENT_H
#define READSEGMENT_H

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <cstdlib>

/* Unfriendly */

using namespace::std;

const short BlockSize = 16384;

class Rdf{

    private:
        static int EventCount;
        static int BlockCount;
        FILE * rdf;
        short BlockData[BlockSize/2];
        short SegmentElement[16];

        short Element;
        short EventWords;

        short ReadWords(short *data){
            return(*data & 0x0fff);
        }

        /* Not Used */
        short ReverseEndian(short *data){
            return((*data & 0x00ff) << 8 | (*data & 0xff00) >> 8);
        }

        inline void NextBlock(){

            for(int i=0; i<16; i++){
                scaler[i] += BlockData[BlockSize/2-32+2*i];
            }

            BlockCount++;
            fread(BlockData, sizeof(short), BlockSize/2, rdf);
            if((unsigned short)BlockData[0]==0xffff){
                EndOfEvent=false;
                return;
            }
            Element = 4;
        }

        inline void NextEvent(){
           EventWords=0;
            if((unsigned short)BlockData[Element]==0xffff)
                NextBlock();
        };



    public:
        Rdf(void);
        ~Rdf(void);

    /* For 16ch scaler */
        int scaler[16];

    /* It can tell the end of loop */
        bool EndOfEvent;

    /* Core member functions */
        void OpenRdf(char *filename);
        void CloseRdf();
        void SortRdf();
        short* ReadSegment(short SegID, short Event);
        short SegAuthenticity(short segID);
        void ShowEventStatus(){
            cout << " Event Block  : " << BlockCount << endl;
            cout << " Event Number : " << EventCount << endl;
        }

};
#endif //READSEGMENT_H
