#include "ChannelMap.h"

#define LINELEN_MAX 200
//#define N_MODULE_MAX  20
//#define N_CHANNEL_MAX 64


int ChannelMap::Map(int n_mod, int n_channel) {
  int mapped_id=0, error=0;
  if ((n_mod < 0) || (n_mod > maxmodule)) {
      cerr << "Error: module id=" << n_mod << " Out of range." << endl; 
      error=1;
  }

  if (n_channel<0 || n_channel > maxchannel)  {
    cerr << "Error: channel=" << n_channel << " Out of range." << endl; 
    error=1;
  }

  if (!error) {
    mapped_id=maparray[n_mod][n_channel];
  }

  return mapped_id;
}

int ChannelMap::ReadMap() {
  ifstream in;

  char line[LINELEN_MAX+10];
  //  int  n_ana,n_word,n_id,n_id_first,n_id_last;
  //  char tmp_n_id[100],*tmp_name,*tmp_range,*tmp_aiw;
  //  char *tmp_name1,*tmp_name2,*tmp_name_n;
  //  char prefix1[SEGNAMELEN_MAX], prefix2[SEGNAMELEN_MAX];
  //  int  n_prefix1=0, n_prefix2=0;
  int id, nmod, nchannel;
  char temp1[LINELEN_MAX];


  in.open(filename,ios::in);


  in.getline(line,LINELEN_MAX);

  while (!in.eof()) {

    in.getline(line,LINELEN_MAX);

    if (line[0]=='#' || line[0]=='c') continue;
    
    // To show the map file contents
    //    cerr << line << endl;
    int ret0=sscanf(line,"%d%[^0-9]%d%[^0-9]%d%s",&id,temp1,&nchannel,temp1,&nmod,temp1);
    if (ret0==-1) continue;
    if ((id < 0) || (id > maxmodule*maxchannel)) {
      cerr << "Error: id=" << id << " Out of range." << endl; 
      continue;
    }
    if ((nmod < 0) || (nmod > maxmodule)) {
      cerr << "Error: Nmod=" << nmod << " Out of range." << endl; 
      continue;
    }
    if (nchannel<0 || nchannel > maxchannel)  {
      cerr << "Error: Nchannel=" << nchannel << " Out of range." << endl; 
      continue;
    }

    if (id>maxid) maxid=id;
    SetMapDatum(id,nmod,nchannel);
    //    cout << dec <<"id: " << id << " (" << nmod << "," << nchannel   << ")" << endl; 
    //    cout << "read parts: "<< ret0 << "; "<< line << endl;
  }

  //  cout << "Max channel/max module" <<  maxchannel << " " << maxmodule << endl;

  // cout << "close file" << endl;
  //  in2->close();
  map_read=true;

  //cout << "finishing map file readout" << endl;
  
  return 0;  
}



ChannelMap::ChannelMap() {
  map_read=false;
  maxid=0;
  for (int i=0;i<=maxmodule;i++) {
    for (int j=0;j<=maxchannel;j++) {
      SetMapDatum(0,i,j);
    }
  }


}

void ChannelMap::PrintMap() {
  for (int i=1;i<=maxmodule;i++) {
    for (int j=1;j<=maxchannel;j++) {
      int id=Map(i,j);
      if (id>0){
	cout << dec << "id=" << id << " (mod,chan)=(" << i << "," << j << ")"<<endl;  
      }
    }
  }
}
