#include <iostream>
#include <string>
#include <TApplication.h>
#include <TTree.h>
#include <TFile.h>
#include <time.h>
#include <stdlib.h>
#include <yaml-cpp/yaml.h>
#include "ReadSegment.h"
#include "DataDecoder.h"
#include "ChannelMap.h"
#include "FillBranch.h"
//#include "Ppac_prm.h"

using namespace::std;

Int_t main(Int_t argc, Char_t **argv){
    char rdf[100],RdfName[100];
    int runNum = atoi(argv[1]);

    sprintf(RdfName,"%04d.rdf",runNum);
 
    FillBranch *fillbranch = new FillBranch();
    fillbranch->ReadRecipe(runNum);
    fillbranch->CreateBranch();

    sprintf(rdf,"rdf/%s",RdfName);
    Rdf *data = new Rdf();
    data->OpenRdf(rdf);

    int EventNum=0;
    int SegId_max = fillbranch->MaxSegId;

    DataDecoder *decoder[SegId_max+1];
   while(data->EndOfEvent){
//    for(int k=0; k<10;k++){
        data->SortRdf();
        EventNum++;
//        cout << " Event " << EventNum << endl;
        fillbranch->clear();
     for(int SegId=0; SegId<=SegId_max; SegId++){
        if(fillbranch->SegFlag[SegId]){
         if(fillbranch->DecodeType[SegId] == "Raw"){
            decoder[SegId] = new DataDecoder("");
          }
          else if(fillbranch->DecodeType[SegId] == "Bit"){
            decoder[SegId] = new DataDecoder("Bit");
          }
          else if(fillbranch->DecodeType[SegId] == "LeCroy"){
            decoder[SegId] = new DataDecoder("LeCroy",fillbranch->MapName[SegId].c_str());
          }
          else if(fillbranch->DecodeType[SegId] == "CAEN"){
            decoder[SegId] = new DataDecoder("CAEN",fillbranch->MapName[SegId].c_str());
          }

          decoder[SegId]->Decode(data->SegAuthenticity(SegId),data->ReadSegment(SegId,0),fillbranch->SegData[SegId]);
            fillbranch->BranchFill(SegId,fillbranch->SegData); 
        } //end of if(SegFlag)
        }//end of loop SegId
       fillbranch->FillTree();
    if(EventNum%100000==0) cout<<EventNum<<'\t'<<"events completed"<<endl;
    } //end of loop event
 
    data->ShowEventStatus();
    data->CloseRdf();

    fillbranch->RecodeScaler(data->scaler);

    fillbranch->CreateRootFile();

    delete data;
    for(int i=0;i<=SegId_max;i++){
      if(fillbranch->SegFlag[i]) delete decoder[i];
    }
    delete fillbranch;
    return 0;
}
